unit UnitMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,system.Math,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,System.StrUtils,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Layouts, FMX.ExtCtrls,
  FMX.WebBrowser, FMX.TabControl,FMX.Clipboard,FMX.PLatform,System.Rtti,
  FMX.Memo.Types, FMX.ScrollBox, FMX.Memo, FMX.Maps, FMX.EditBox, FMX.NumberBox,
  FMX.Edit, System.ImageList, FMX.ImgList;

type
  TMainForm = class(TForm)
    StatusBar1: TStatusBar;
    LabelStatus: TLabel;
    Tabcontrol1: TTabControl;
    TabItemMaps: TTabItem;
    WebBrowser1: TWebBrowser;
    TabItemKarte: TTabItem;
    ImageViewer1: TImageViewer; // Enthlt Google maps Kopie
    ImageViewer2: TImageViewer;
    TabItemProt: TTabItem;
    Memo1: TMemo;
    TabItemParameter: TTabItem;
    ButtonWaypts: TButton;
    Button5: TButton;
    CheckBoxFormat: TCheckBox;
    EditAufloesung: TEdit;
    EditDXFFileName: TEdit;
    EditF: TEdit;
    EditXb: TEdit;
    EditYb: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    NumberBoxA: TNumberBox;
    NumberBoxB: TNumberBox;
    NumberBoxBA: TNumberBox;
    NumberBoxBG: TNumberBox;
    NumberBoxFlaeche: TNumberBox;
    NumberBoxFlugzeit: TNumberBox;
    NumberBoxFrameS: TNumberBox;
    NumberBoxH: TNumberBox;
    NumberBoxLG: TNumberBox;
    NumberBoxP: TNumberBox;
    NumberBoxQ: TNumberBox;
    NumberBoxRi: TNumberBox;
    NumberBoxV: TNumberBox;
    NumberBoxWeg: TNumberBox;
    OpenDialog1: TOpenDialog;
    TabItemLitchi: TTabItem;
    NumberBoxLat: TNumberBox;
    NumberBoxAlt: TNumberBox;
    NumberBoxHead: TNumberBox;
    NumberBoxLon: TNumberBox;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    NumberBoxCuSz: TNumberBox;
    Label26: TLabel;
    Label27: TLabel;
    NumberBoxGimM: TNumberBox;
    Label28: TLabel;
    NumberBoxGimP: TNumberBox;
    Label29: TLabel;
    NumberBoxAltMode: TNumberBox;
    NumberBoxSpeed: TNumberBox;
    NumberBoxPictS: TNumberBox;
    NumberBoxPictM: TNumberBox;
    NumberBoxPoiLon: TNumberBox;
    NumberBoxPoiAltMode: TNumberBox;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    NumberBoxTiltCam: TNumberBox;
    Label38: TLabel;
    NumberBoxWait: TNumberBox;
    NumberBoxRotate: TNumberBox;
    Label39: TLabel;
    Label15: TLabel;
    EditCVS: TEdit;
    Button6: TButton;
    Button7: TButton;
    CheckBoxAlle: TCheckBox;
    Label37: TLabel;
    NumberBoxActrec: TNumberBox;
    NumberBoxRotDir: TNumberBox;
    NumberBoxPoiAlt: TNumberBox;
    CheckBoxPhoto: TCheckBox;
    CheckBoxStartRec: TCheckBox;
    CheckBoxStopRec: TCheckBox;
    Button8: TButton;
    Button9: TButton;
    ImageList1: TImageList;
    NumberBoxBilder: TNumberBox;
    Label12: TLabel;
    Button1: TButton;
    Label14: TLabel;
    NumberBoxStreifen: TNumberBox;
    NumberBoxPoiLat: TNumberBox;
    ButtonSaveBF: TButton;
    ButtonLoadBF: TButton;
    EditBFName: TEdit;
    Label40: TLabel;
    SaveDialog1: TSaveDialog;
    ToolBar1: TToolBar;
    ButtonTrafo: TButton;
    ButtonMapCopy: TButton;
    ButtonBorder: TButton;
    ButtonFreeline: TButton;
    ButtonPOI: TButton;
    ButtonPoly: TButton;
    ButtonMove: TButton;
    ButtonPtDel: TButton;
    ButtonMessen: TButton;
    ButtonDelAll: TButton;
    ButtonHelp: TButton;
    ButtonArea: TButton;
    ToolBar2: TToolBar;
    TabItemHelp: TTabItem;
    Memo2: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure ButtonTrafoClick(Sender: TObject);
    procedure ButtonPOIClick(Sender: TObject);
    procedure ButtonMapCopyClick(Sender: TObject);
    procedure ImageViewer2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure ImageViewer2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure ButtonBorderClick(Sender: TObject);
    procedure NumberBoxPChange(Sender: TObject);
    procedure ButtonWayptsClick(Sender: TObject);
    procedure NumberBoxQChange(Sender: TObject);
    procedure NumberBoxHChange(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure NumberBoxActrecChange(Sender: TObject);
    procedure NumberBoxAltChange(Sender: TObject);
    procedure NumberBoxAltModeChange(Sender: TObject);
    procedure NumberBoxCuSzChange(Sender: TObject);
    procedure NumberBoxGimMChange(Sender: TObject);
    procedure NumberBoxGimPChange(Sender: TObject);
    procedure NumberBoxSpeedChange(Sender: TObject);
    procedure NumberBoxRotDirChange(Sender: TObject);
    procedure NumberBoxPoiLatChange(Sender: TObject);
    procedure NumberBoxPoiLonChange(Sender: TObject);
    procedure NumberBoxHeadChange(Sender: TObject);
    procedure NumberBoxPictSChange(Sender: TObject);
    procedure NumberBoxPictMChange(Sender: TObject);
    procedure NumberBoxTiltCamChange(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure NumberBoxVChange(Sender: TObject);
    procedure TabItemKarteClick(Sender: TObject);
    procedure ButtonDelAllClick(Sender: TObject);
    procedure CheckBoxFormatClick(Sender: TObject);
    procedure ButtonFreelineClick(Sender: TObject);
    Procedure ShowFreeline;
    Procedure MakeFreeLitchiLines;
    procedure Button1Click(Sender: TObject);
    procedure ButtonPolyClick(Sender: TObject);
    procedure ButtonPtDelClick(Sender: TObject);
    procedure ButtonHelpClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure TabItemMapsDblClick(Sender: TObject);
    procedure EditBFNameDblClick(Sender: TObject);
    procedure ButtonSaveBFClick(Sender: TObject);
    procedure ButtonLoadBFClick(Sender: TObject);
    procedure ButtonMessenClick(Sender: TObject);
    procedure ButtonAreaClick(Sender: TObject);
    procedure ButtonMoveClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure ShowPoints;
    Procedure TrafPar;
    Procedure SavePar;
    Procedure LoadPar;
    Procedure Trafall;
    Procedure Trafone(xb,yb:single;var E,N:Double);
    Procedure Trafback(X,Y:Double; var xb,yb:Double);
    procedure WaitUntilData;
    Function SelPoint(x,y:single):Integer;
    Procedure Showpoint(j:Integer);
    Procedure Hidepoint(j:Integer);
    Procedure ShowBorder;
    Procedure Rechnen;
    Procedure CalcFlugWeg;
    Procedure SetBorderPointer;
    procedure DisplayBorderLine;
    Procedure CalcBorderMinMax;
    procedure Schnitte(Ri:Double);
    Procedure Showfly;
    Procedure FlightLines;
    procedure SchreibDXF;
    Procedure ReadLitchiCVS;
    Procedure ShowLitchiCVS(i:Integer);
    procedure DisplayLitchiRecs;
    procedure WriteLitchiCVS;
    Procedure MakeLitchiLines;
    Procedure SetFreeLine;
    Procedure DisplayFreeline;
    Function FindNearestPOI(n:integer):Integer;
    Procedure Polygon(xb,yb,R:Single;n:Integer);
    procedure Showgrafik;

  end;

  TPt=record
      B,L,E,N,c:Double;
      xb,yb:single;
      Typ:Byte; // 0=Freier Punkt 1= Passpunkt 2=BorderLine 3=Freeline 4=POI
//      PP:boolean;
//      BD:Boolean;
//      FL:Boolean;
  end;
  Tpunkt=Array[0..1] of Double;
  TLine=Array[0..1] of Integer;
  TLitchiActions=Record
             Typ:Integer;
             Param:Double;
           end;
  TlitchRec=Record
             latitude:Single;
             longitude:Single;
             altitude:Single;
             heading:Single;
             curvesize:Single;
             rotationdir:Single;
             gimbalmode:Integer;
             gimbalpitchangle:Single;
             Actions:Array[1..15] of TLitchiActions;
             altitudemode:Integer;
             speed:Single;
             poi_latitude:Single;
             poi_longitude:Single;
             poi_altitude:Single;
             poi_altitudemode:Integer;
             photo_timeinterval:Integer;
             photo_distinterval:Single;
           end;

  TPara=Record
    a,o,xas,yas,xns,yns:Double;
  end;

  Torbit=class(Tobject)
  Public
    P:array of TPt;
    L:array of Tline;
    R:Single;
    n:Integer;
    procedure Make(xb,yb,R:single;n:Integer);
    procedure Transformation;
    Procedure Show;
    Procedure Makelitchi;
  end;

  TFlightRaster=class(TObject)
  public
     map:string;
     a,o,m,xaoff,yaoff,xnoff,ynoff:Double;
     npoints,nPoly,nFly,nFreel,nOrbit:integer;
     P:Array of Tpunkt;
     Poly,Lfy,Freel:Array of TLine;
     Orbit:TOrbit;
     Procedure Make;
     procedure Write;
     Procedure Read;
  end;
var
  MainForm: TMainForm;
  cx,cy:single;
  Svc: IFMXExtendedClipboardService;
  v:Tvalue;
  Pt:array of TPt;
  pa,pe:Tpt;
  Rhod,a,f,oo,aa,mf,oob,aab,mfb,eps,ysa,xsa,ysn,xsn,Maxx,Minx,MaxY,MinY,xs,ys:Double;
  PtSel:Integer;
  SaveBMP:Tbitmap;
  P:Array of integer;
  PFly:array of TPunkt;
  Pol,FreeL:Array of Tline;
  LFly:array of Tline;
  dxffile:textfile;
  DXFFilename,RasterFilename:String;
  DXFIsOpen:Boolean;
  XOff,YOff:Double;
  AktLitchRec:Integer;
  LWP:array of TLitchRec;
  Orbit:Torbit;
  Raster:TflightRaster;

implementation

{$R *.fmx}
{$R *.Windows.fmx MSWINDOWS}
{$R *.LgXhdpiTb.fmx ANDROID}
{$R *.LgXhdpiPh.fmx ANDROID}
{$R *.Surface.fmx MSWINDOWS}

function sgn(x:Double):integer;
(* Eingabe: X = Doublewert
   Ausgabe: 0 falls x=0, 1 falls x>0, -1 falls x<0
*)
begin
  sgn:=0;
  if x<0 then sgn:=-1
  else if x>0 then sgn:=1;
end;

Procedure RIWI(dy,dx : Double;var S,T:Double);
(* Berechnet Richtungswinkel und Entfernung *)
Begin
  If DX = 0 Then T := sgn(dy)*Pi/2
  Else T := ArcTan(dy/DX);
  If DX < 0 Then T := T+Pi;
  If T < 0 Then T := T+Pi+Pi;
  S := Sqrt(dy*dy+DX*DX);
  If (DX = 0) And (dy = 0) Then
  begin
    T := 0;S:=0;
  end;
End;

procedure Heading(p1,p2:Tpt;var az,Dist:Double);
var dx,dy:Double;
begin
  dx:=p2.N-p1.N;
  dy:=p2.E-P1.E;
  RIWI(dy,dx,dist,az);
  az:=az*RhoD+p1.c;
end;

procedure DXFOpen;
begin
  assignfile(DXFFile,DXFFileName);
  Rewrite(DXFFile);
  writeln(DXFFile,0:3);
  writeln(DXFFIle,'SECTION');
  Writeln(DXFFIle,2:3);
  Writeln(DXFFile,'ENTITIES');
  DXFIsOpen:=True;
end;

procedure DXFClose;
begin
  if DXFIsOpen then
  begin
    Writeln(DXFFile,0:3);
    writeln(DXFFile,'ENDSEC');
    writeln(DXFFile,0:3);
    writeln(DXFFIle,'EOF');
    Closefile(DXFFIle);
    DXFIsOpen:=False;
  end;
end;

procedure DXFLinie(x1,y1,z1,x2,y2,z2:Double;Layer,LTyp:String);
begin
  writeln(DXFFile,0:3);
  Writeln(DXFFIle,'LINE');
  writeln(DXFFile,8:3);
  Writeln(DXFFIle,LAYER);
  writeln(DXFFile,6:3);
  Writeln(DXFFIle,LTYP);
  writeln(DXFFile,10:3);
  Writeln(DXFFIle,X1);
  writeln(DXFFile,20:3);
  Writeln(DXFFIle,Y1);
  writeln(DXFFile,30:3);
  Writeln(DXFFIle,Z1);
  writeln(DXFFile,11:3);
  Writeln(DXFFIle,X2);
  writeln(DXFFile,21:3);
  Writeln(DXFFIle,Y2);
  writeln(DXFFile,31:3);
  Writeln(DXFFIle,Z2);
end;

procedure DXFPunkt(x,y,z:Double;Layer,LTyp:String);
begin
  writeln(DXFFile,0:3);
  Writeln(DXFFIle,'POINT');
  writeln(DXFFIle,8:3);
  Writeln(DXFFIle,LAYER);
  Writeln(DXFFile,6:3);
  Writeln(DXFFile,LTyp);
  Writeln(DXFFile,10:3);
  writeln(DXFFile,X);
  Writeln(DXFFile,20:3);
  Writeln(DXFFile,Y);
  Writeln(DXFFile,30:3);
  Writeln(DXFFile,Z);
end;


procedure DXFText(x,y,z:Double;Text,Layer,LTyp:String;Alfa,Height:Real;Pos:Byte);
begin
  writeln(DXFFile,0:3);
  Writeln(DXFFIle,'TEXT');
  writeln(DXFFIle,8:3);
  Writeln(DXFFIle,LAYER);
  Writeln(DXFFile,6:3);
  Writeln(DXFFile,LTyp);
  Writeln(DXFFile,10:3);
  writeln(DXFFIle,X);
  Writeln(DXFFile,20:3);
  Writeln(DXFFile,Y);
  Writeln(DXFFile,30:3);
  Writeln(DXFFile,Z);
  Writeln(DXFFile,40:3);
  Writeln(DXFFile,Height);
  Writeln(DXFFile,1:3);
  Writeln(DXFFile,Text);
  Writeln(DXFFile,50:3);
  Writeln(DXFFile,Alfa:10:4);
end;

Procedure DXFKreis(X,Y,z,Radius:Double;Layer,LTyp:String);
begin
  writeln(DXFFile,0:3);
  Writeln(DXFFIle,'CIRCLE');
  writeln(DXFFIle,8:3);
  Writeln(DXFFIle,LAYER);
  Writeln(DXFFile,6:3);
  Writeln(DXFFile,LTyp);
  Writeln(DXFFile,10:3);
  writeln(DXFFIle,X);
  Writeln(DXFFile,20:3);
  Writeln(DXFFile,-Y);
  Writeln(DXFFile,30:3);
  Writeln(DXFFile,Z);
  Writeln(DXFFile,40:3);
  Writeln(DXFFile,Radius);
end;


procedure ELLinKONF(Art:Byte;L0:Integer;a,f,B,L:Double;var X,Y,C,M:Double);
var e2,e4,e6,e8,cp,n2,V,N,CosB,CosB2,CosB3,COSB4,CosB5,COSB6,CosB7,TANB,
    dL,dL2,dL3,dL4,dL5,K0,K2,K4,K6,G,K3Y,K5Y,K4X,K3C,K2M,K4M,m0,RhoD:Double;
(*
  Literatur: Schdelbauer Rechenformeln zur Landesvermessung B.1.3
  Bei bis zu 11 breiten Meridianstreifen mm-Genauigkeit
  Eingabe: Art: 0=Gau-Krger 1=UTM
           L0: Mittelmeridian des Meridianstreifens
           a:Groe Halbachse
           f: Abplattung
           B,L: Ellipsoidische Koordinaten
  Ausgabe: X,Y Konforme Koordinaten in voller Lnge
           Y enthlt Meridiankennziffer
           C:Meridainkonvergenz in Gon
           M:Mastab
*)
begin
  RhoD:=180/Pi;
  m0:=1;
  case art of
  0: m0:=1;      (* Gauss-Krger *)
  1: m0:=0.9996; (* UTM *)
  end;

  B:=B/RhoD;
  cosB:=cos(B);
  CosB2:=CosB*CosB;
  CosB3:=cosB2*CosB;
  CosB4:=cosB2*CosB2;
  CosB5:=CosB3*CosB2;
  CosB6:=cosB5*CosB;
  CosB7:=CosB6*CosB;
  TANB:=sin(B)/Cos(b);

  e2:=(2*f-f*f)/(1-(2*f-f*f));
  cp:=a/sqrt(1-(2*f-f*f));

  e4:=e2*e2;
  e6:=e4*e2;
  e8:=e6*e2;
  n2:=e2*Sqr(cos(B));
  V:=Sqrt(1+n2);
  N:=cp/V;
  (* Meridianbogen *)
  K0:=cp*(1-3/4*e2+45/64*e4-175/256*e6+11025/16384*e8);
  K2:=cp*(-3/8*e2+15/32*e4-525/1024*e6+2205/4096*e8);
  K4:=cp*(15/256*e4-105/1024*e6+2205/16384*e8);
  K6:=cp*(-35/3072*e6+315/12288*e8);
  G:=K0*B+K2*sin(2*B)+K4*sin(4*B)+K6*sin(6*B);

  dL:=(L-L0)/RhoD;
  dL2:=dl*dL;
  dL3:=dL2*dL;
  dL4:=dL2*dL2;
  dL5:=dL3*dL2;

  K3Y:=m0/6*e2*N*CosB5;
  K5Y:=m0*e2*N/60*CosB7*(7-29*SQR(TANB));
  K4X:=m0*3/8*e2*N*COSB6*TANB;
  K3C:=e2*COSB5*TANB;
  K2M:=m0*e2/2*COSB4;
  K4M:=m0*e2/12*COSB6*(7-14*sqr(TANB));

  X:=m0*N*arctan(tan(B)/cos(dL))+m0*(G-N*B)+K4X*dL4;
  Y := m0*0.5*N*Ln((1+CosB*Sin(dL))/(1-CosB*Sin(dL))) +
       K3Y*dL3 + K5Y*dL5+500000;
  case Art of
  0: Y:=Y+trunc(L0/3)*1E6;
  1: Y:=Y+Trunc((L0+3)/6+30)*1E6;
  end;
  C:=arctan(sin(B)*sin(dL)/Cos(dL)) + K3C*dL3;
  C:=C*RhoD;
  m:=m0/sqrt(1-sqr(cos(B))*sqr(sin(dL))) + K2M*dL2 + K4M*dL4;
end;

procedure KONFinEll(Art:Byte;a,f,X,Y:Real;var B,L,C,M:Double);
var e2,e4,e6,e8,cp,n2f,Vf,A0,A2,A4,A6,Bf,KB2,KB4,KL3,KL5,KC3,KM2,KM4,
    CosBf,CosBf2,TanBf,m0,m02,m03,m04,m05,
    Ys,Y2,Y3,Y4,Y5,Nf,NF2,NF3,NF4,Nf5,RhoD:Double;
    L0:Integer;
(*
  Literatur: Schdelbauer Rechenformeln zur Landesvermessung B.2.3
  Bei bis zu 11 breiten Meridianstreifen mm-Genauigkeit
  Eingabe: Art: 0=Gau-Krger 1=UTM
           a:Groe Halbachse
           f: Abplattung
           X,Y: konforme Koordinaten
           Y-Wert mit Kennziffer und X-Wert in VollerLnge bergeben
  Ausgabe: B,L Breite, Lnge in Dezimalaltgrad
           C:Meridainkonvergenz in Grad
           M:Mastab
*)
begin
  m0:=1;L0:=0; RhoD:=180/Pi;
  case Art of
  0: begin
       m0:=1;       (* Gau-Krger *)
       L0:=trunc(Y/1E6);
       Y:=Y-(L0*1E6+500000);
       L0:=L0*3;
     end;
  1: begin
       m0:=0.9996;   (* UTM *)
       L0:=Trunc(Y/1E6);
       Y:=Y-(L0*1E6+500000);
       L0:=(L0-30)*6-3;
     end;
  end;

  e2:=(2*f-f*f)/(1-(2*f-f*f));
  cp:=a/sqrt(1-(2*f-f*f));

  e4:=e2*e2;
  e6:=e4*e2;
  e8:=e6*e2;

  (* Meridianbogen *)
  A0:=m0*cp*(1-3/4*e2+45/64*e4-175/256*e6+11025/16384*e8);
  A2:=         3/8*e2-3/16*e4+213/2048*e6-255/4096*e8;
  A4:=              21/256*e4-21/256*e6+533/8192*e8;
  A6:=                      151/6144*e6-453/12288*e8;

  Bf:=X/A0 + A2*sin(2*X/A0) + A4*sin(4*X/A0) + A6*sin(6*x/A0);

  n2f:=e2*Sqr(cos(Bf));
  Vf:=Sqrt(1+n2f);
  Nf:=cp/Vf;
  CosBF:=Cos(Bf);
  CosBF2:=CosBF*CosBF;
  TanBf:=Tan(Bf);
  m02:=m0*m0;
  m03:=m02*m0;
  m04:=m02*m02;
  m05:=m03*m02;

  Nf2:=Nf*Nf;
  Nf3:=Nf2*Nf;
  Nf4:=Nf2*Nf2;
  Nf5:=Nf4*nf;


  KB2:=-e2/2/m02/Nf2*CosBF2*TANBF;
  KB4:=e2/4/m04/Nf4*CosBf2*TanBf*(1-Sqr(tanBF));
  KL3:=-e2/6/m03/Nf3*CosBf;
  KL5:=e2/60/m05/Nf5*CosBf*(3+4*Sqr(TanBf));
  KC3:=e2/3/m03/Nf3*CosBf2*TanBf;
  KM2:=e2/2/m0/Nf2*CosBf2;
  KM4:=Sqr(e2)/4/m04/Nf4*CosBf2;

  yS:=2*ArcTan(Power(Exp(1),y/m0/Nf))-Pi/2;
  Y2:=Y*Y;
  Y3:=Y2*Y;
  Y4:=Y2*Y2;
  Y5:=Y4*Y;
  B:=arcsin(cos(yS)*sin(Bf))+ KB2*y2 + KB4*y4;
  L:=arctan(tan(yS)/cos(Bf)) + KL3*Y3 + KL5*Y5;
  C:=Arctan(Sin(YS)*TanBf) + KC3*Y3;
  M:=m0/Cos(Ys) + KM2*Y2 + KM4*Y4;
  B:=B*RhoD;
  L:=L0+L*RhoD;
  C:=C*RhoD;
end;

function PolyArea(p:Array of Integer): Double;
var
  n, i, j: Integer;
  a: Double;
begin
  Result:=0;
  n := Length(p);
  if n>1 then
  begin
    a := 0;
    for i := 0 to n-1 do
    begin
      j := (i+1) mod n;
      a := a +pt[p[i]].E*pt[p[j]].N-Pt[p[i]].N*pt[p[j]].E;
    end;
    a := a / 2;
    result := abs(a);
  end;
end;

Function Geradenschnitt(x1,y1,x2,y2,x3,y3,x4,y4:Double;var xs,ys:Double):Boolean;
var N,sa,sb,s:Double;
begin
  XS:=NAN;YS:=NAN;Result:=False;
  N:=((x1-x2)*(y3-y4)-(y1-y2)*(x3-x4));
  if (abs(N)<>0) then
  begin
    xs:= ( (x1*y2-y1*x2)*(x3-x4)-(x1-x2)*(x3*y4-y3*x4) ) / N;
    ys:= ( (x1*y2-y1*x2)*(y3-y4)-(y1-y2)*(x3*y4-y3*x4) ) / N;
    // Schnittpunkte nur zwischen P1 und P2 zulassen
    sa:=sqrt(sqr(xs-x1)+sqr(ys-y1));
    sb:=sqrt(sqr(xs-x2)+sqr(ys-y2));
    s:=sqrt(sqr(x2-x1)+sqr(y2-y1));
    If (sa<=s) and (sb<=s)then Result:=True;
  end;
end;

procedure TMainForm.ButtonTrafoClick(Sender: TObject);
begin
 TrafPar;
 Trafall;
 ShowGrafik;
 //showpoints;
end;

procedure Tmainform.Savepar;
var f:file of double;
    i:integer;
    n,x,y:Double;
    s:string;
begin
  assignfile(f,EditBFName.text);
  rewrite(f);
  write(f,oo,aa,ysa,xsa,ysn,xsn);
  n:=high(pt);
  write(f,n);
  for i:=low(pt) to High(pt) do
  begin
    n:=pt[i].Typ;
    x:=pt[i].xb;
    y:=Pt[i].yb;
    write(f,pt[i].B,pt[i].L,pt[i].E,pt[i].N,pt[i].c,x,y,n);
  end;
  Closefile(f);
  i:=pos('.',EditBFName.Text);
  if i>0 then
  begin
    s:=Leftstr(EditBFName.Text,i);
  end
  else s:=EditBFName.Text;
  Imageviewer1.Bitmap.SaveToFile(s+'jpg');
end;

procedure Tmainform.Loadpar;
var f:file of Double;
     n,x,y:double;
     i:integer;
     s:string;
begin
  assignfile(f,EditBFName.Text);
  reset(f);
  Read(f,oo,aa,ysa,xsa,ysn,xsn,n);
  setlength(pt,0);
  for i:=0 to trunc(n) do
  begin
    setlength(pt,length(pt)+1);
    Read(f,pt[i].B,pt[i].L,pt[i].E,pt[i].N,pt[i].c,x,y,n);
    pt[i].xb:=x;Pt[i].yb:=y;
    pt[i].Typ:=Byte(trunc(n));
  end;
  Closefile(f);

  i:=pos('.',EditBFName.Text);
  if i>0 then
  begin
    s:=Leftstr(EditBFName.Text,i);
  end
  else s:=EditBFName.Text;
  s:=s+'jpg';
  if imageviewer1.Bitmap.IsEmpty then imageviewer1.Bitmap.CreateFromFile(s)
  else
    Imageviewer1.Bitmap.loadFromFile(s);
end;

procedure TMainForm.ButtonWayptsClick(Sender: TObject);
begin
//  TrafPar;
  Rechnen;
  ShowGrafik;
  Showpoints;
  FlightLines;

  (*
  Trafall;
  Rechnen;
  showpoints;
  flightLines;
  *)
end;

Procedure TMainForm.SetFreeLine;
var i:Integer;
begin
  //P enthlt Zeiger auf Pt
  setlength(P,0);
  setlength(Pol,0);
  for i:=low(pt) to high(pt) do
  begin
    if pt[i].Typ=3 then
    begin
      // neuer Umringspunkt
      setlength(P,length(P)+1);
      P[high(P)]:=i;
    end;
  end;

  // Linien in FreeL definieren
  setlength(FreeL,0);
  for i:=low(p) to high(P)-1 do
   begin
     setlength(FreeL,length(FreeL)+1);
     FreeL[High(FreeL)][0]:=P[i];FreeL[high(FreeL)][1]:=P[i+1];
   end;
//   TrafPar;
   Trafall;
end;

procedure TMainForm.DisplayFreeLine;
var i:integer;
    p1,p2:Tpointf;
begin
  Tabcontrol1.GotoVisibleTab(1);
  for i:=low(FreeL) to high(FreeL) do
  begin
    p1:=tpointf.Create(Pt[FreeL[i][0]].xb,Pt[FreeL[i][0]].yb);
    p2:=tpointf.Create(Pt[FreeL[i][1]].xb,Pt[FreeL[i][1]].yb);
  If Imageviewer2.Canvas.BeginScene then
    try
    Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Blue;
    Imageviewer2.Canvas.Stroke.Thickness:=1;
    imageviewer2.Canvas.DrawLine(p1,p2,1);
    finally
    Imageviewer2.Canvas.EndScene;
    end;
  end;
end;

Procedure TMainForm.SetBorderPointer;
var i:Integer;
begin
  //P enthlt Zeiger auf Pt
  setlength(P,0);
  setlength(Pol,0);
  for i:=low(pt) to high(pt) do
  begin
    if pt[i].Typ=2 then
    begin
      // neuer Umringspunkt
      setlength(P,length(P)+1);
      P[high(P)]:=i;
    end;
  end;
  // Umring schlieen
  setlength(p,length(p)+1);
  P[high(P)]:=P[0];

  // Umringsseiten in Pol definieren
  setlength(pol,0);
    for i:=low(p) to high(P)-1 do
   begin
     setlength(pol,length(pol)+1);
     Pol[High(Pol)][0]:=P[i];Pol[high(pol)][1]:=P[i+1];
   end;
//   TrafPar;
   Trafall;
   if Length(P)>0 then NumberBoxFlaeche.Value:=PolyArea(P)/10000;
end;

procedure TMainForm.DisplayBorderLine;
var i:integer;
    p1,p2:Tpointf;
begin
  Tabcontrol1.GotoVisibleTab(1);
  for i:=low(pol) to high(pol) do
  begin
    p1:=tpointf.Create(Pt[Pol[i][0]].xb,Pt[Pol[i][0]].yb);
    p2:=tpointf.Create(Pt[Pol[i][1]].xb,Pt[Pol[i][1]].yb);
  If Imageviewer2.Canvas.BeginScene then
    try
    Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow;
    Imageviewer2.Canvas.Stroke.Thickness:=1;
    imageviewer2.Canvas.DrawLine(p1,p2,1);
    finally
    Imageviewer2.Canvas.EndScene;
    end;
  end;

end;

Procedure TMainForm.CalcBorderMinMax;
var i,n:Integer;
begin
 Minx:=1E10;Miny:=1E10;MaxX:=-1E10;MaxY:=-1E10;
 xs:=0;ys:=0;n:=0;
  for i:=low(P) to high(P) do
  begin
    if Pt[P[i]].Typ=2 then
    begin
      if pt[p[i]].E<MinX then MinX:=Pt[p[i]].E;
      if pt[p[i]].N<MinY then MinY:=Pt[p[i]].N;
      if pt[p[i]].E>MaxX then Maxx:=Pt[p[i]].E;
      if pt[p[i]].N>MaxY then MaxY:=Pt[p[i]].N;
      xs:=xs+pt[P[i]].E;ys:=ys+Pt[P[i]].N;
      inc(n);
    end;
  end;
  if n>0 then
  begin
    xs:=xs/n;ys:=ys/n;
  end;

end;

Procedure TMainForm.FlightLines;
begin
//  Trafpar;
  Trafall;
  SetBorderPointer;
  if Length(P)>0 then
  begin
    DisplayBorderline;
    CalcBorderMinMax;
    schnitte(NumberboxRI.Value);
 //  showfly;
   CalcFlugWeg;
//   SetLitchRec;
//  LitchiCVS;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  If Length(Freel)>0 then MakeFreeLitchilines;
end;

procedure TMainForm.ButtonMapCopyClick(Sender: TObject);
begin
 imageviewer1.Bitmap.Assign(webbrowser1.CaptureBitmap);
end;


procedure TMainForm.ButtonMessenClick(Sender: TObject);
begin
  ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
//  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
  Showpoints;
end;

procedure TMainForm.ButtonMoveClick(Sender: TObject);
begin
  ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  //ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
  Showpoints;
end;

procedure TMainForm.ButtonPOIClick(Sender: TObject);
begin
  labelstatus.Text:='Point of interest festlegen';
  ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
//  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
  Showpoints;
end;

procedure TMainForm.ButtonPolyClick(Sender: TObject);
begin
  labelstatus.Text:='POI und Orbit festlegen';
  ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  //ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
  if ButtonPoly.IsPressed=false then DisplayFreeline;
  Showpoints;
end;

procedure TMainForm.ButtonPtDelClick(Sender: TObject);
begin
  ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
//  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
  Showpoints;
end;

procedure TMainForm.ButtonSaveBFClick(Sender: TObject);
begin
  savePar;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
  schreibdxf;
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
  WriteLitchiCVS;
end;

procedure TMainForm.Button7Click(Sender: TObject);
begin
  ReadLitchiCVS;
  DisplayLitchiRecs;
end;

procedure TMainForm.Button8Click(Sender: TObject);
begin
  DisplayLitchiRecs;
end;

procedure TMainForm.Button9Click(Sender: TObject);
begin
  MakeLitchiLines;
end;

procedure TMainForm.ButtonAreaClick(Sender: TObject);
begin
  ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
 // ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
end;

procedure TMainForm.ButtonBorderClick(Sender: TObject);
begin
  labelstatus.Text:='Gebietsumring im Uhrzeigersinn definieren';
  //ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
  SetBorderPointer;
  DisplayBorderline;
end;

procedure TMainForm.ButtonDelAllClick(Sender: TObject);
begin
  ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  //Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
  setlength(pt,0);
  setlength(Pfly,0);
  Labelstatus.Text:='Alle Punkte gelscht, Passpunkte neu fetlegen.';
end;

procedure TMainForm.ButtonFreelineClick(Sender: TObject);
begin
  labelstatus.Text:='Flugweg frei festlegen';
  ButtonBorder.IsPressed:=false;
//  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
  ButtonHelp.IsPressed:=False;
  if ButtonFreeline.IsPressed=false then
  begin
    SetFreeLine;
    DisplayFreeline;
  end;
end;

procedure TMainForm.ButtonHelpClick(Sender: TObject);
begin
  ButtonBorder.IsPressed:=false;
  ButtonFreeLine.IsPressed:=false;
  ButtonPoly.IsPressed:=false;
  ButtonPoi.IsPressed:=False;
  Buttondelall.IsPressed:=False;
  Buttonptdel.IsPressed:=false;
  ButtonMessen.IsPressed:=false;
  ButtonMove.IsPressed:=False;
  ButtonArea.isPressed:=False;
//  ButtonHelp.IsPressed:=False;
  TabitemHelp.Visible:=ButtonHelp.Ispressed;
  Memo2.Lines.LoadFromFile('Help.txt');
end;

procedure TMainForm.ButtonLoadBFClick(Sender: TObject);
begin
  LoadPar;
  ShowGrafik;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FormatSettings.DecimalSeparator:='.';
  FormatSettings.ThousandSeparator:=',';
  RHod:=180/Pi;
  a:=6378137.000;
  f:= 1/298.257222101;
  eps:=0;mf:=1;

  if TPlatformServices.Current.SupportsPlatformService(IFMXClipboardService, Svc) then
  begin
    v:=svc.GetClipboard;
    v:='';
    SVC.SetClipboard(v);
  end;
  setlength(p,0);
end;

Function TMainForm.SelPoint(x,y:Single):integer;
var i,j:Integer;
    d,dmin:double;
begin
  dmin:=1E12;j:=-1;
  for i:=low(Pt) to high(Pt) do
  begin
    d:=sqrt(sqr(Pt[i].xb-x)+sqr(Pt[i].yb-y));
    if d<dmin then
    begin
      dmin:=d;j:=i;
    end;
  end;
  Result:=j;
end;

procedure TMainForm.ImageViewer2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var s:String;
    k,i:Integer;
    xx,yy,c,m:Double;
    p1,p2:TpointF;
    B,L:tvalue;
begin
  if Sender=imageviewer2 then
  begin
    Y:=y+Toolbar1.Height+TabitemKarte.Height;

  case Button of
  Tmousebutton.mbright:
    if svc.HasText then
    begin
      v:=svc.GetClipboard;
      s:=V.asString;
      k:=0;
      for i:=Low(s) to High(s) do if s[i]=',' then inc(k);
      if k>1 then FormatSettings.DecimalSeparator:=',';

      setlength(Pt,length(Pt)+1);
      if s<>'' then
      begin
         if k>1 then k:=pos(',',s);
         k:=pos(',',s,k+1);
         Pt[high(Pt)].B:=strtoFloat(copy(s,0,k-1));
         delete(s,1,k);
         Pt[high(Pt)].L:=Strtofloat(s);
         EllinKonf(1,9,a,f,Pt[high(pt)].B,Pt[high(pt)].L,Pt[high(Pt)].N,Pt[high(Pt)].E,c,m);
         Pt[high(Pt)].Xb:=X;
         Pt[high(Pt)].Yb:=Y;
         Pt[high(Pt)].Typ:=1;
       end;
       v:='';
       FormatSettings.DecimalSeparator:='.';
       SVC.SetClipboard(v);
       Pt[high(Pt)].Typ:=1;
    end;

  Tmousebutton.mbLeft:
  begin
     if ButtonPtDel.IsPressed then
     begin
       PtSel:=SelPoint(x,y);
       if Ptsel>=0 then
       begin
         for i:=ptsel to high(pt)-1 do pt[i]:=pt[i+1];
         setlength(Pt,length(pt)-1);
       end;
       ShowGrafik;
       ShowPoints;
       Exit;
     end;

    if ButtonPoly.IsPressed then
    begin
      pa.xb:=x;pa.yb:=y;
      exit;
    end;

    if ButtonMessen.IsPressed then
    begin
      pa.xb:=x;Pa.yb:=y;
      Trafone(pa.xb,pa.yb,pa.E,pa.N);
    end
    else
     if ButtonMove.IsPressed then
     begin
       PtSel:=SelPoint(x,y);
     end
     else
     begin
       setlength(Pt,length(Pt)+1);
       Pt[high(Pt)].xb:=x;
       Pt[high(Pt)].yb:=y;
       Pt[high(Pt)].Typ:=0;

       if ButtonBorder.IsPressed then
       begin
         Pt[high(Pt)].Typ:=2;
         ShowBorder;
         //SetBorderPointer;
         //Displayborderline;
       end;

       if ButtonFreeline.IsPressed then
       begin
         Pt[high(pt)].Typ:=3;
         ShowFreeline;
       end;

       if ButtonPoi.IsPressed then
       begin
         Pt[high(pt)].Typ:=4;
       end;
     end;
    Showgrafik;
    Showpoints;

  end;
  end;

  end;
end;

procedure TMainForm.ImageViewer2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
  var r,s:Double;
begin
  Y:=y+Toolbar1.Height+TabitemKarte.Height;
  if ButtonMessen.IsPressed then
  begin
    pe.xb:=x;Pe.yb:=y;
    Trafone(x,y,pe.E,pe.N);
    Heading(pa,pe,r,s);
    Labelstatus.Text:=format('E %10.2f N %10.2f Az %10.3f Dist %10.3f',[Pe.N,pe.E,r,s]);
  end;

  if ButtonPoly.IsPressed then
  begin
    R:=sqrt(sqr(pa.xb-x)+sqr(pa.yb-y));
    //Polygon(pa.xb,pa.yb,R,12);
    If Orbit=NIl then Orbit:=Torbit.Create;
    orbit.Make(pa.xb,pa.yb,R,12);
    Orbit.Transformation;
    Orbit.Show;
    Orbit.Makelitchi;
  end;


  if ButtonMove.IsPressed then
  begin
   Pt[Ptsel].xb:=x;
   Pt[ptsel].yb:=y;
   Trafone(pt[Ptsel].xb,pt[ptsel].yb,pt[ptsel].E,pt[ptsel].N);
//   Showpoint(Ptsel);
  end;

  //ShowGrafik;
  Showpoints;
end;

procedure TMainForm.Polygon(xb,yb,R:single;n:Integer);
var i:Integer;
    xm,ym,alfa,t:Double;
begin
  Trafone(xb,yb,xm,ym);

  alfa:=360/n/RhoD;t:=0;
  if 2*r*tan(alfa/2)<10 then r:=5/tan(alfa/2)
  else
    if 2*r*tan(alfa/2)>500 then
    begin
      n:=n*2;
      Alfa:=alfa/2;
    end;


  Setlength(pt,length(pt)+1);
  pt[high(pt)].xb:=xb;
  pt[high(pt)].yb:=yb;
  pt[high(pt)].Typ:=4;

  for i:=1 to n do
  begin
    setlength(pt,length(pt)+1);
    pt[high(pt)].xb:=xb+R*sin(t);
    pt[high(pt)].yb:=yb+R*cos(t);
    pt[high(pt)].Typ:=3;
    t:=t-alfa;
  end;
  for i:=high(pt)-n+1 to high(pt)-1 do
  begin
    setlength(FreeL,length(Freel)+1);
    FreeL[high(Freel)][0]:=i;
    FreeL[high(Freel)][1]:=i+1;
  end;
  setlength(FreeL,length(Freel)+1);
  FreeL[high(Freel)][0]:=high(Pt);
  FreeL[high(Freel)][1]:=high(Pt)-n+1;
  trafall;
end;

procedure TOrbit.Make(xb,yb,R:single;n:Integer);
var i:Integer;
    xm,ym,alfa,t:Double;
begin
  alfa:=360/n/RhoD;t:=0;
  if 2*r*tan(alfa/2)<10 then r:=5/tan(alfa/2)
  else
    if 2*r*tan(alfa/2)>500 then
    begin
      n:=n*2;
      Alfa:=alfa/2;
    end;
  // Mittelpunkt setzen
  Setlength(p,1);
  p[0].xb:=xb;
  p[0].yb:=yb;
  p[0].Typ:=4;
  // Randpunkte setzen
  for i:=1 to n do
  begin
    setlength(p,length(p)+1);
    p[high(p)].xb:=xb+R*sin(t);
    p[high(p)].yb:=yb+R*cos(t);
    p[high(p)].Typ:=3;
    t:=t-alfa;
  end;
  // Linien stezen
  setlength(l,0);
  for i:=high(p)-n+1 to high(p)-1 do
  begin
    setlength(L,length(L)+1);
    L[high(L)][0]:=i;
    L[high(L)][1]:=i+1;
  end;
  setlength(L,length(L)+1);
  L[high(L)][0]:=high(P);
  L[high(L)][1]:=high(P)-n+1;
end;

procedure TOrbit.Transformation;
var i:Integer;
    m:double;
begin
  for i:=low(p) to High(P) do
  begin
    Mainform.Trafone(P[i].Xb,P[i].yb,P[i].E,P[i].N);
    Konfinell(1,a,f,P[i].N,P[i].E,P[i].B,P[i].L,P[i].c,m);
  end;
end;

Procedure Torbit.Show;
var i:Integer;
   p1,p2:Tpointf;
   r:Integer;
begin
  For i:=low(L) to High(L) do
  begin
    p1:=tpointf.Create(P[L[i][0]].xb,P[L[i][0]].yb);
    p2:=tpointf.Create(P[L[i][1]].xb,P[L[i][1]].yb);

    If Mainform.Imageviewer2.Canvas.BeginScene then
     try
      Mainform.Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Blue;
      Mainform.Imageviewer2.canvas.Fill.Color:=TAlphaColors.Blue;
      Mainform.Imageviewer2.Canvas.Stroke.Thickness:=1;
      Mainform.imageviewer2.Canvas.DrawLine(p1,p2,100);
     finally
     Mainform.Imageviewer2.Canvas.EndScene;
     end;
  end;

  for i:=low(P) to high(P) do
  begin
    p1:=tpointf.Create(P[i].xb,P[i].yb);
    if Mainform.Imageviewer2.Canvas.beginScene then
    try
      r:=5;
      case P[i].Typ of
      0:begin
          Mainform.Imageviewer2.Canvas.Stroke.Color := TAlphaColors.lightBlue;
          Mainform.Imageviewer2.canvas.Fill.Color:=TAlphaColors.lightBlue;
        end;
      1:begin
         Mainform.Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Magenta;
         Mainform.Imageviewer2.canvas.Fill.Color:=TAlphaColors.Magenta;
        end;
      2:begin
          Mainform.Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow;
          Mainform.Imageviewer2.canvas.Fill.Color:=TAlphaColors.Yellow;
        end;
      3:begin
          Mainform.Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Blue;
          Mainform.Imageviewer2.canvas.Fill.Color:=TAlphaColors.Blue;
        end;
      4:begin
          Mainform.Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Cyan;
          Mainform.Imageviewer2.canvas.Fill.Color:=TAlphaColors.Cyan;
          r:=10;
        end;
      end;
      Mainform.Imageviewer2.Canvas.FillEllipse(TRectF.create(p1.x-r,p1.y-r,P1.x+r,P1.y+r),100);
      Mainform.Imageviewer2.Canvas.FillText(TrectF.Create(P1.x,P1.y-r,P1.x+20+r,p1.y+r),inttostr(i),false,100,[TFillTextFlag.RightToLeft], TTextAlign.Leading, TTextAlign.Center);
    finally
      Mainform.Imageviewer2.Canvas.EndScene;
    end;
  end;
end;

Procedure Torbit.Makelitchi;
var i,j:Integer;
    az,d:double;
begin
  setlength(LWP,0);
  j:=1;
  For i:=low(Orbit.L)+1 to high(Orbit.L) do
  begin
    setlength(LWP,length(LWP)+1);
    inc(j);
    Heading(Orbit.P[i],Orbit.P[j],az,D);

    LWP[high(LWP)].poi_latitude:=Orbit.P[0].B;
    LWP[high(LWP)].Poi_longitude:=Orbit.P[0].L;

    LWP[high(LWP)].latitude:=Orbit.P[i].B;
    LWP[high(LWP)].longitude:=Orbit.P[i].L;
    LWP[high(LWP)].heading:=az;
  end;
end;


procedure TMainForm.Rechnen;
var LG,BG,sB,sH,c,mb,p,q,v:Double;
begin
//  HeaderFooterForm.BeginUpdate;

  p:=NumberBoxP.Value;
  q:=NumberboxQ.Value;
  c:=Strtofloat(EDitf.Text)/1000;
  v:=NumberboxV.Value*1000/3600; // km/h in m/s
  sb:=Strtofloat(EditAufloesung.text)/1E6*strtofloat(editXb.text);
  sh:=Strtofloat(EditAufloesung.text)/1E6*strtofloat(editYb.text);
  mb:=NumberBoxH.Value/c;

  BG:=sb*mb;
  LG:=sh*mb;
  NumberBoxlG.Value:=LG;
  NumberboxbG.Value:=BG;
  Numberboxa.Max:=numberboxlG.Value;
  NumberboxB.Max:=numberboxbg.Value;
  Numberboxa.value:=LG*(1-Numberboxp.Value/100);
  NumberboxB.value:=BG*(1-Numberboxq.Value/100);

  NumberboxFrameS.Value:=NumberBoxA.Value/v;
  NumberboxBa.Text:=FloatTostr(Strtofloat(Editaufloesung.Text)*4/10000*mb);
 end;

procedure TMainForm.NumberBoxActrecChange(Sender: TObject);
begin
  NumberboxActRec.Max:=high(LWP);

  AktLitchRec:=Trunc(NumberboxActRec.value);

  //LabelAktLine.Text:=format('Streifen %d von %d',[AktLitchRec,High(LWP)+1]);
  showLitchicvs(AktLitchRec);
end;

procedure TMainForm.NumberBoxAltChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].altitude:=NumberboxAlt.Value
  else Lwp[AktLitchrec].altitude:=NumberboxAlt.Value   ;
end;


procedure TMainForm.NumberBoxGimPChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].gimbalpitchangle:=NumberboxGimP.Value
   else Lwp[AktLitchRec].gimbalpitchangle:=NumberboxGimP.Value ;
end;


procedure TMainForm.NumberBoxGimMChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].gimbalmode:=Trunc(NumberboxGImM.Value)
  else Lwp[AktLitchrec].gimbalmode:=Trunc(NumberboxGImM.Value);
end;


procedure TMainForm.NumberBoxCuSzChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].curvesize:=NumberboxCuSz.Value
  else Lwp[AktLitchrec].curvesize:=NumberboxCuSz.Value;
end;


procedure TMainForm.NumberBoxAltModeChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].altitudemode:=Trunc(NumberboxAltMode.Value)
  else Lwp[AktLitchrec].altitudemode:=Trunc(NumberboxAltMode.Value);
end;

procedure TMainForm.NumberBoxHChange(Sender: TObject);
begin
  Rechnen;
end;

procedure TMainForm.NumberBoxHeadChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].heading:=NumberboxHead.Value
  else Lwp[AktLitchrec].Heading:=NumberboxHead.Value;
end;

procedure TMainForm.NumberBoxPChange(Sender: TObject);
begin
  Rechnen;
end;

procedure TMainForm.NumberBoxPictMChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].photo_distinterval:=NumberboxPictM.Value
  else Lwp[AktLitchrec].photo_distinterval:=NumberboxPictM.Value;

end;

procedure TMainForm.NumberBoxPictSChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].photo_timeinterval:=Trunc(NumberboxPicts.Value)
  else Lwp[AktLitchrec].photo_timeinterval:=trunc(NumberboxPicts.Value);
end;

procedure TMainForm.NumberBoxPoiLatChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].poi_latitude:=NumberboxPoiLat.Value
   else Lwp[AktLitchRec].poi_latitude:=NumberboxPoiLat.Value;
end;

procedure TMainForm.NumberBoxPoiLonChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].poi_longitude:=NumberboxPoiLon.Value
  else Lwp[AktLitchRec].poi_longitude:=NumberboxPoiLon.Value;
end;

procedure TMainForm.NumberBoxQChange(Sender: TObject);
begin
  Rechnen;
end;

procedure TMainForm.NumberBoxRotDirChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].rotationdir:=NumberboxRotDir.Value
  else Lwp[AktLitchRec].rotationdir:=NumberboxRotDir.Value;
end;

procedure TMainForm.NumberBoxSpeedChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].speed:=NumberboxSpeed.Value
  else Lwp[AktLitchRec].speed:=NumberboxSpeed.Value;
  Label14.Text:=Format('%4.1f',[NumberboxSpeed.Value*3.6]);
end;


procedure TMainForm.NumberBoxTiltCamChange(Sender: TObject);
var i:Integer;
begin
  if CheckboxAlle.IsChecked=true then
     for i:=Low(LWP) to high(LWP) do Lwp[i].gimbalpitchangle:=Trunc(NumberboxTiltCam.Value)
  else Lwp[AktLitchrec].gimbalpitchangle:=trunc(NumberboxTiltCam.Value);

end;

procedure TMainForm.NumberBoxVChange(Sender: TObject);
begin
  Rechnen;
end;

Procedure TMainForm.showpoints;
var i:Integer;
    r:integer;
begin
   Tabcontrol1.GotoVisibleTab(1);
   for i:=low(Pt) to high(Pt) do
   begin
      r:=5;
      if Imageviewer2.Canvas.BeginScene then
      try
      case Pt[i].Typ of
      0:begin
          Imageviewer2.Canvas.Stroke.Color := TAlphaColors.lightBlue;
          Imageviewer2.canvas.Fill.Color:=TAlphaColors.lightBlue;
        end;
      1:begin
         Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Magenta;
         Imageviewer2.canvas.Fill.Color:=TAlphaColors.Magenta;
        end;
      2:begin
          Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow;
          Imageviewer2.canvas.Fill.Color:=TAlphaColors.Yellow;
        end;
      3:begin
          Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Blue;
          Imageviewer2.canvas.Fill.Color:=TAlphaColors.Blue;
        end;
      4:begin
          Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Cyan;
          Imageviewer2.canvas.Fill.Color:=TAlphaColors.Cyan;
          r:=10;
        end;
      end;

      Imageviewer2.Canvas.Stroke.Thickness:=1;
      Imageviewer2.Canvas.DrawEllipse(TrectF.Create(Pt[i].xb-r,Pt[i].yb-r,Pt[i].xb+r,pt[i].yb+r),100);
      Imageviewer2.Canvas.FillEllipse(TrectF.Create(Pt[i].xb-r,Pt[i].yb-r,Pt[i].xb+r,pt[i].yb+r),100);
      Imageviewer2.Canvas.FillText(TrectF.Create(Pt[i].xb,Pt[i].yb-r,Pt[i].xb+20+r,pt[i].yb+r),inttostr(i),false,100,[TFillTextFlag.RightToLeft], TTextAlign.Leading, TTextAlign.Center);
      finally
      Imageviewer2.Canvas.EndScene;
      end;
   end;
end;

Procedure TMainForm.ShowFreeLine;
var i:Integer;
   p1,p2:Tpointf;
begin
  i:=low(Pt);
  repeat
     If Pt[i].Typ=3 then p1:=tpointf.Create(Pt[i].xb,Pt[i].yb);
     inc(i);
     If Pt[i].Typ=3 then p2:=tpointf.Create(Pt[i].xb,Pt[i].yb);
     if (p1.Distance(p2)>0) and (p1.Y>0.01)  then
    If Imageviewer2.Canvas.BeginScene then
     try
     Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Blue;
     Imageviewer2.Canvas.Stroke.Thickness:=1;
     imageviewer2.Canvas.DrawLine(p1,p2,1);
     finally
     Imageviewer2.Canvas.EndScene;
     end;
  until i=high(Pt);
end;

Procedure TMainForm.ShowBorder;
var i:Integer;
   p1,p2:Tpointf;
begin
  i:=low(Pt);
  repeat
     If Pt[i].Typ=2 then p1:=tpointf.Create(Pt[i].xb,Pt[i].yb);
     inc(i);
     If Pt[i].Typ=2 then p2:=tpointf.Create(Pt[i].xb,Pt[i].yb);
     if (p1.Distance(p2)>0) and (p1.Y>0.01)  then
    If Imageviewer2.Canvas.BeginScene then
     try
     Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow;
     Imageviewer2.Canvas.Stroke.Thickness:=1;
     imageviewer2.Canvas.DrawLine(p1,p2,1);
     finally
     Imageviewer2.Canvas.EndScene;
     end;
  until i=high(Pt);
end;

Procedure TMainForm.Showpoint(j:integer);
begin
  if Imageviewer2.Canvas.BeginScene then
  try
    if Pt[j].Typ=1 then
    begin
      Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Magenta;
      Imageviewer2.canvas.Fill.Color:=TAlphaColors.Magenta;
    end
    else
      if Pt[j].Typ=2 then
      begin
        Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow;
        Imageviewer2.canvas.Fill.Color:=TAlphaColors.Yellow;
      end
      else
      begin
        Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Blue;
        Imageviewer2.canvas.Fill.Color:=TAlphaColors.Blue;
      end;
  Imageviewer2.Canvas.Stroke.Thickness:=1;
  Imageviewer2.Canvas.DrawEllipse(TrectF.Create(Pt[j].xb-5,Pt[j].yb-5,Pt[j].xb+5,pt[j].yb+5),100);
  Imageviewer2.Canvas.FillText(TrectF.Create(Pt[j].xb,Pt[j].yb-5,Pt[j].xb+25,pt[j].yb+5),inttostr(j),false,100,[TFillTextFlag.RightToLeft], TTextAlign.Leading, TTextAlign.Center);
  finally
  Imageviewer2.Canvas.EndScene;
  end;
 end;


Procedure TMainForm.Hidepoint(j:integer);
begin
  if Imageviewer2.Canvas.BeginScene then
  try
  if Pt[j].Typ=1 then Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow
  else  Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Blue;
  Imageviewer2.Canvas.Stroke.Thickness:=1;
  Imageviewer2.Canvas.DrawEllipse(TrectF.Create(Pt[j].xb-5,Pt[j].yb-5,Pt[j].xb+5,pt[j].yb+5),100);
  Imageviewer2.Canvas.FillText(TrectF.Create(Pt[j].xb,Pt[j].yb-5,Pt[j].xb+25,pt[j].yb+5),inttostr(j),false,100,[TFillTextFlag.RightToLeft], TTextAlign.Leading, TTextAlign.Center);
  finally
  Imageviewer2.Canvas.EndScene;
  end;
end;

procedure TMainForm.Trafpar;
var dya,dxa,dyn,dxn,sa,sn,xx,yy,xy,yx,x,y,vx,vy,vv,m0,mp,c,d:Double;
  i,n:Integer;
begin
   // Schwerpunkt
   ysa:=0;xsa:=0;xsn:=0;ysn:=0;n:=0;
   for i:=Low(Pt) to High(Pt) do
   begin
     if Pt[i].Typ=1 then
     begin
       xsa:=xsa+pt[i].xb;
       ysa:=ysa+pt[i].yb;
       ysn:=ysn+pt[i].E;
       xsn:=xsn+pt[i].N;
      inc(n);
     end;
   end;

   xsa:=xsa/n;ysa:=ysa/n;
   xsn:=xsn/n;ysn:=ysn/n;
   // Parameter
   xx:=0;xy:=0;yx:=0;yy:=0;sn:=0;sa:=0;c:=0;d:=0;

   for i := Low(Pt) to High(Pt) do
     if Pt[i].Typ=1 then
     begin
       dya:=Pt[i].yb-ysa;
       dxa:=Pt[i].xb-xsa;
       dxn:=pt[i].N-xsn;
       dyn:=pt[i].E-ysn;

       xx:=xx+dya*dyn; yy:=yy+dxa*dxn;
       xy:=xy+dxa*dyn; yx:=yx+dya*dxn;
       C:=C+ dya*dya+dxa*dxa;
       D:=D+ dyn*dyn+dxn*dxn;
     end;
   aa:=(xx+yy)/C;oo:=(xy-yx)/C;
   mf:=sqrt(oo*oo+aa*aa);
   // Fehlerrechnung
   vv:=0;m0:=0;mp:=0;
   Memo1.lines.Add('Passpunkttransformation');
   for i:=Low(pt) to high(Pt) do
     if Pt[i].Typ=1 then
     begin
      dxa:=Pt[i].xb-xsa;
      dya:=Pt[i].yb-ysa;
      Y:=ysn+oo*dxa+aa*dya;
      X:=xsn+aa*dxa-oo*dya;
      vx:=X-Pt[i].N;vy:=Pt[i].E-Y;
      vv:=vv+vx*vx+vy*vy;
      memo1.Lines.Add(format('%4d x%6.2f y%6.2f E%12.2f N%12.2f vE%6.2f vN%6.2f',[i,Pt[i].xb,pt[i].yb,Y,X,vy,vx]));
     end;

   if n>1 then
   begin
     m0:=sqrt(vv/(n*2-2));
     mp:=m0*sqrt(2);
   end;
   memo1.Lines.Add(format('ybs %5.0f xbs %5.0f Ys %10.2f Xs %10.2f o %10.6f a %10.6f M %10.6f m0 %10.6f mp %10.2f',[ysa,xsa,ysn,xsn,oo,aa,mf,m0,mp] ));
   Labelstatus.text:=format('Transformation: Masstab 1:%10.6f m0 %10.6f mp %10.2f',[mf,m0,mp] );
   if mp<2 then Showmessage('Transformation ist OK!');
end;



procedure TMainForm.WaitUntilData;
begin
  repeat until SvC.HasText;
  if svc.HasText then
  begin
    v:=svc.GetClipboard;
    LabelStatus.Text:=V.asString;
  end;
end;

procedure TMainForm.TabItemMapsDblClick(Sender: TObject);
begin
  if Pos('google',webbrowser1.URL)>0 then
  begin
    webbrowser1.URL:='https://www.bing.com/maps';
    TabitemMaps.Text:='Bing Maps';
  end
  else
  begin
    webbrowser1.URL:='https://www.google.de/maps';
//    webbrowser1.URL:='https://earth.google.com/web';
    TabitemMaps.Text:='Google Maps';
  end;
end;

procedure TMainForm.TabItemKarteClick(Sender: TObject);
begin
//  Imageviewer2.Bitmap.Assign(Imageviewer1.Bitmap);
  ShowPoints;
  if Orbit<>NIl then Orbit.Show;
  if length(Pfly)>0 then FlightLines;
  if length(Freel)>0 then DisplayFreeline;
end;

Procedure TMainForm.Trafall;
var i:integer;
    dxa,dya,X,Y,m:Double;
    s:string;
begin
  for i:=Low(pt) to high(Pt) do
  begin
    dxa:=Pt[i].xb-xsa;
    dya:=Pt[i].yb-ysa;
    Y:=ysn+oo*dxa+aa*dya;
    X:=xsn+aa*dxa-oo*dya;
    if Pt[i].E=0 then
    begin
      Pt[i].E:=Y;
      Pt[i].N:=X;
      Konfinell(1,a,f,x,y,Pt[i].B,Pt[i].L,Pt[i].c,m);
    end;
//    s:=format('%5d B %10.6f L %10.6f xb %4.0f yb%4.0f E %10.2f N %10.2f vY %8.2f vX %8.2f ',[i,Pt[i].B,Pt[i].L,Pt[i].xb,Pt[i].yb,Pt[i].N,Pt[i].E,Pt[i].N-Y,Pt[i].E-x]);
    case Pt[i].Typ of
      0:;
      1:s:=s+' PP';
      2:s:=s+' BD';
      3:s:=s+' FL';
    end;
//    memo1.lines.add(s);
  end;

end;

Procedure TMainForm.Trafone(xb,yb:single;var E,N:Double);
var
    dxa,dya:Double;

begin
    dxa:=xb-xsa;
    dya:=yb-ysa;
    E:=ysn+oo*dxa+aa*dya;
    N:=xsn+aa*dxa-oo*dya;
//    s:=format('xb %4.0f yb%4.0f E %10.2f N %10.2f',[xb,yb,Y,X]);
//    memo1.lines.add(s);
end;

Procedure TMainForm.Trafback(X,Y:Double; var xb,yb:Double);
var
    dxn,dyn:Double;

begin
  dxn:=x-xsn;
  dyn:=y-ysn;
  yb:=ysa+( -oo*dxn-aa*dyn)/(oo*oo+aa*aa);
  xb:=xsa+( -aa*dxn+oo*dyn)/(oo*oo+aa*aa);
end;
(*
procedure TForm4.ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
var wd:hwnd;
begin
//  wd:=webbrowser1.HWND;
 // if (Msg.hwnd=webbrowser1.HWND) then
//    if msg.message=WM_LBUTTONDOWN then memo1.Lines.Add('LeftButton');

  if (Msg.hwnd = IEServerWindow) then
  begin
    if (Msg.message = WM_LBUTTONDOWN) or (Msg.message = WM_RBUTTONDOWN)
      or (Msg.message = WM_MBUTTONDOWN) then
      begin
       //ActiveControl := WebBrowser1;
       memo1.Lines.Add(format('Buttondown %5d %5d',[msg.pt.x,msg.pt.y]));
       handled:=false;
      end;
  end;
end;
*)

procedure TMainForm.Schnitte(ri:Double);
const Overlap=100;
type TLines=Record x1,y1,x2,y2:Double; end;

var i,j,n,aktline,nlines:Integer;
    r,x0,y0,t,ts,s1,t1,s2,t2,Alfa1,Alfa2,dy1,dy2,x1,y1,x2,y2,x3,y3,x4,y4,
    xb1,yb1,xb2,yb2,sx,sy,xb3,yb3,xb4,yb4,dy,dx,o,a,Yt1,xT1,yT2,xT2:Double;
    p1,p2:Tpointf;
    s:String;
    LR:array of TLines;
    pu:Tpunkt;
begin
  CalcBorderMinMax;
  x0:=(minx+maxx)/2;y0:=(miny+Maxy)/2;
  if Ri=0 then Ri:=0.01;
  Ri:=ri/RhoD;

  setlength(Pfly,0);
  Setlength(Lfly,0);

  if (Maxx-minx)>(maxy-MinY) then
       nlines:=Trunc((Maxx-Minx+Overlap)/NumberboxB.Value)
  else nlines:=Trunc((maxy-Miny+Overlap)/NumberboxB.Value);
  nLines:=nlines*2;

  setlength(LR,nlines+1);

  maxX:=maxX+Overlap;Minx:=minx-Overlap;maxy:=maxy+Overlap;Miny:=miny-Overlap;
  for i:=0 to nlines do
  begin
    LR[i].x1:=minx+NumberboxB.Value*i;
    LR[i].y1:=MinY;
    LR[i].x2:=minx+NumberboxB.Value*i;
    LR[i].y2:=MaxY;
  end;


  setlength(Lfly,0);
  aktLine:=High(LFly);

   for j:=Low(LR) to high(LR) do
   begin
     x1:=LR[j].x1;y1:=lr[j].y1;
     x2:=lr[j].x2;y2:=LR[j].y2;

     RIWI(x1-x0,y1-y0,s1,t1);
     RIWI(x2-x0,y2-y0,s2,t2);
     x1:=X0+s1*cos(t1+ri);Y1:=Y0+s1*sin(t1+Ri);
     x2:=X0+s2*cos(t2+ri);Y2:=Y0+s2*sin(t2+Ri);

     n:=0;
     for i:=low(pol) to high(pol) do
     begin
       x3:=pt[pol[i][0]].E;Y3:=pt[pol[i][0]].N;
       x4:=pt[pol[i][1]].E;Y4:=pt[pol[i][1]].N;

       if Geradenschnitt(x3,y3,x4,y4,x1,y1,x2,y2,sx,sy) then
       begin
         setlength(Pfly,length(Pfly)+1);
         PFly[High(Pfly)][0]:=sx;PFly[High(Pfly)][1]:=sy;

         if n=0 then
         begin
//           LR[j].x1:=sx;LR[j].y1:=sy;
           setlength(lfly,length(Lfly)+1);
           Lfly[High(LFly)][0]:=High(Pfly);
           inc(n);
         end
         else
         begin
//           LR[j].x2:=sx;LR[j].y2:=sy;
           Lfly[High(Lfly)][1]:=High(Pfly);
           n:=0;
             // Flight lines sollen gleichen Richtungssinn haben
           dx:=PFly[Lfly[high(LFly)][0]][0]-PFly[LFly[high(LFly)][1]][0];
           dy:=PFly[LFly[high(LFly)][0]][1]-PFly[LFly[high(LFly)][1]][1];
           RIWI(dy,dx,s1,t);
           If High(Lfly)=0 then ts:=t
           else if Abs(t-ts)>0.1 then
           begin
             Pu:=Pfly[Lfly[high(Lfly)][0]];
             Pfly[LFly[high(Lfly)][0]]:=Pfly[Lfly[high(Lfly)][1]];
             PFly[Lfly[high(Lfly)][1]]:=Pu;
            end;
         end;
       end;
     end;

     inc(aktline);
   end;
  setlength(LR,0);
end;

procedure TMainForm.ShowFly;
var i:Integer;
   p1,p2:Tpointf;
   xb1,yb1,xb2,yb2:double;

begin
  if imageviewer2.Canvas.BeginScene then
  try
   Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow;
   Imageviewer2.Canvas.Stroke.Thickness:=1;
   finally
     imageviewer2.Canvas.endScene
  end;

  for i:=low(lfly) to high(Lfly) do
  begin
    trafback(Pfly[Lfly[i][0]][0],Pfly[Lfly[i][0]][1],xb1,yb1);
    p1:=TPointf.Create(XB1,YB1);
    trafback(Pfly[Lfly[i][1]][0],Pfly[Lfly[i][1]][1],xb2,yb2);
    p2:=TPointf.Create(XB2,YB2);
    if Imageviewer2.Canvas.BeginScene then
    try
     Imageviewer2.Canvas.DrawLine(p1,p2,100);
     //Imageviewer2.Canvas.FillText(TrectF.Create(xb1,yb1-5,xb1+25,yb1+5),inttostr(i),false,100,[TFillTextFlag.RightToLeft], TTextAlign.Leading, TTextAlign.Center);
    finally
     Imageviewer2.Canvas.endScene
    end;
  end;
end;


Procedure TMainForm.CalcFlugWeg;
var i:Integer;
    d,dmax,XP1,YP1,XP2,YP2,XB1,YB1,XB2,YB2,s,t,y,x:Double;
    p1,p2:Tpointf;
    tex:string;
begin
  if length(PFly)=0 then exit;

  dmax:=0; NumberboxBilder.Value:=0;
  if Imageviewer2.Canvas.BeginScene then
  try
    Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow;
    Imageviewer2.Canvas.Stroke.Thickness:=1;
  finally
    Imageviewer2.Canvas.endScene;
  end;
  // Streifenzeichnen
  for i:=low(Lfly) to high(Lfly) do
  begin
    if i Mod 2 =0 then
    begin
      Yp1:=Pfly[Lfly[i][0]][0];Xp1:=Pfly[Lfly[i][0]][1];
      Yp2:=Pfly[Lfly[i][1]][0];Xp2:=Pfly[Lfly[i][1]][1];
    end
    else
    begin
      Yp2:=Pfly[Lfly[i][0]][0];Xp2:=Pfly[Lfly[i][0]][1];
      Yp1:=Pfly[Lfly[i][1]][0];Xp1:=Pfly[Lfly[i][1]][1];
    end;
    RIWI(yp2-yp1,xp2-xp1,s,t);

    dmax:=dmax+s;
    trafback(XP1,YP1,XB1,YB1);
    trafback(XP2,YP2,XB2,YB2);
    p1:=TPointf.Create(XB1,YB1);
    p2:=TPointf.Create(XB2,YB2);
    if Imageviewer2.Canvas.BeginScene then
    try
     Imageviewer2.Canvas.DrawLine(p1,p2,100);
    finally
     Imageviewer2.Canvas.endScene
    end;

    // Bildmittelpunkte zeichnen
    d:=0;
    while d<=S do
    begin
      y:=yP1+d*Sin(t);
      X:=Xp1+d*cos(t);
      Trafback(x,y,xb1,yb1);
      if Imageviewer2.Canvas.BeginScene then
      try
        Imageviewer2.Canvas.DrawEllipse(TrectF.Create(xb1-2,yb1-2,xb1+2,yb1+2),100);
        Imageviewer2.canvas.Fill.Color:=TAlphaColors.Magenta;
        Imageviewer2.Canvas.FillEllipse(TrectF.Create(xb1-2,yb1-2,xb1+2,yb1+2),100);
      finally
        Imageviewer2.Canvas.endScene
      end;
      NumberboxBilder.Value:=NumberboxBilder.Value+1;
      d:=d+NumberBoxA.value;
    end;
  end;
(*
    if Imageviewer2.Canvas.BeginScene then
    try
      Imageviewer2.Canvas.DrawEllipse(TrectF.Create(xb2-2,yb2-2,xb2+2,yb2+2),100);
    finally
      Imageviewer2.Canvas.endScene
    end;
*)

  // Weg zwischen den Streifen
  i:=0;
  repeat
    i:=i+1;
    Xp1:=Pfly[i][0];Yp1:=Pfly[i][1];
    Xp2:=Pfly[i+2][0];Yp2:=Pfly[i+2][1];
    trafback(XP1,YP1,XB1,YB1);
    trafback(XP2,YP2,XB2,YB2);
    if i Mod 2=0 then i:=i+2;
    if Imageviewer2.Canvas.BeginScene then
    try
      Imageviewer2.Canvas.DrawLine(TpointF.Create(XB1,YB1),TpointF.Create(XB2,YB2),100);
    finally
      Imageviewer2.Canvas.endScene
    end;
      d:=sqrt(sqr(xp2-xp1)+sqr(yp2-yp1));
    dmax:=dmax+d;
  until i>=High(Pfly)-2;
  Numberboxstreifen.Value:=high(Lfly)+1;
  NumberBoxWeg.Value:=dmax;
  NumberboxFlugzeit.Value:=1/(NumberBoxV.Value*1000/NumberboxWeg.Value)*60;
end;


procedure TMainForm.CheckBoxFormatClick(Sender: TObject);
begin
  if CheckboxFormat.IsChecked then
  begin
    CheckboxFormat.Text:='16:9';
    EditXB.Text:='5472';
    EditYb.Text:='3078';
  end
  else
  begin
    CheckboxFormat.Text:='3:2';
    EditXB.Text:='5472';
    EditYb.Text:='3648';
  end;
end;

procedure TMainForm.SchreibDXF;
var i:Integer;
    xP1,yP1,XP2,YP2,d,dmax,s,t:Double;
begin
  DXFFilename:=EditDXFFilename.Text;
  DXFOpen;

  for i:=0 to high(P) do
  begin
    if pt[i].Typ=1 then  DXFPunkt(Pt[i].E,Pt[i].N,0,'Eckpunkte','');
  end;

  for i:=0 to high(pol) do
  begin
    DXFLinie(Pt[Pol[i][0]].E,Pt[Pol[i][0]].N,0,Pt[Pol[i][1]].E,Pt[Pol[i][1]].N,0,'Umring','');
  end;

  dmax:=0;

  for i:=0 to high(Lfly) do
  begin
    if i Mod 2 =0 then
    begin
      Xp1:=Pfly[Lfly[i][0]][1];Yp1:=Pfly[Lfly[i][0]][0];
      Xp2:=Pfly[Lfly[i][1]][1];Yp2:=Pfly[Lfly[i][1]][0];
    end
    else
    begin
      Xp2:=Pfly[Lfly[i][0]][1];Yp2:=Pfly[Lfly[i][0]][0];
      Xp1:=Pfly[Lfly[i][1]][1];Yp1:=Pfly[Lfly[i][1]][0];
    end;
    dxflinie(YP1,XP1,0,YP2,XP2,0,'FlightLine','');
    RIWI(yP2-yP1,XP2-XP1,s,t);
    d:=0;
    while d<=S do
    begin
      yP2:=yP1+d*Sin(t);
      Xp2:=Xp1+d*cos(t);
      DXFPunkt(yp2,xp2,0,'Picture','');
      d:=d+NumberBoxa.value;
    end;
    if (d-Numberboxa.value)<>S then
    begin
      yP2:=yP1+s*Sin(t);
      Xp2:=Xp1+s*cos(t);
      DXFPunkt(yp2,xp2,0,'Picture','');
    end;
    dmax:=dmax+S;
  end;

  for i:=0 to high(LFLy) do
  begin
    Xp1:=Pfly[Lfly[i][0]][1];Yp1:=Pfly[Lfly[i][0]][0];
    Xp2:=Pfly[Lfly[i][1]][1];Yp2:=Pfly[Lfly[i][1]][0];
    DXFText(YP1,XP1,0,Inttostr(LFly[i][0]),'FlightLine','',0.1,10,0);
    DXFText(YP2,XP2,0,Inttostr(LFly[i][1]),'FlightLine','',0.1,10,0);
  end;
  i:=0;
  repeat
    i:=i+1;
    Xp1:=Pfly[i][1];Yp1:=Pfly[i][0];
    Xp2:=Pfly[i+2][1];Yp2:=Pfly[i+2][0];
    if i Mod 2=0 then i:=i+2;
    dxflinie(YP1,XP1,0,YP2,XP2,0,'FlightLine','');
  until i>=High(Pfly)-2;
  DXFClose;
end;

Procedure TMainForm.ReadLitchiCVS;
var LR:TlitchRec;
    s:String;
    tf:Textfile;
    i:Integer;
    cvsdel:String;
    x,y,c,m:Double;

Function NextVal:String;
Var i:Integer;
begin
  i:=pos(CVSDel,S);
  result:=leftstr(S,i-1);
  s:=copy(s,i+1,length(s)-i);
  if Result='' then Result:=s;
end;

begin
  if Opendialog1.Execute then
  begin
   assignfile(tf,Opendialog1.FileName);
   EditCVS.Text:=Opendialog1.FileName;
 end;
  reset(tf);
  setlength(LWP,0);
  Readln(tf,s);
  if pos(';',s)>0 then CvsDel:=';'
  else if Pos(',',S)>0 then CvsDel:=',';
  maxx:=0;maxy:=0;
  Minx:=1E10;Miny:=1E10;MaxX:=-1E10;MaxY:=-1E10;
  xs:=0;ys:=0;

  repeat
//latitude	longitude	altitude(m)	heading(deg)	curvesize(m)	rotationdir	gimbalmode	gimbalpitchangle	actiontype1	actionparam1	actiontype2	actionparam2	actiontype3	actionparam3	actiontype4	actionparam4	actiontype5	actionparam5	actiontype6	actionparam6	actiontype7	actionparam7	actiontype8	actionparam8	actiontype9	actionparam9	actiontype10	actionparam10	actiontype11	actionparam11	actiontype12	actionparam12	actiontype13	actionparam13	actiontype14	actionparam14	actiontype15	actionparam15	altitudemode	speed(m/s)	poi_latitude	poi_longitude	poi_altitude(m)	poi_altitudemode	photo_timeinterval	photo_distinterval

    readln(tf,s);
    LR.latitude:=strtoFloat(Nextval);
    LR.longitude:=StrTofloat(Nextval);
    LR.altitude:=StrTofloat(Nextval);
    LR.heading:=StrTofloat(Nextval);
    LR.curvesize:=StrTofloat(Nextval);
    LR.rotationdir:=StrTofloat(Nextval);
    LR.gimbalmode:=StrToint(Nextval);
    LR.gimbalpitchangle:=StrTofloat(Nextval);
    for i:=1 to 15 do
      begin
        LR.Actions[i].Typ:=StrToInt(Nextval);
        LR.Actions[i].Param:=StrTofloat(Nextval);
      end;
    LR.altitudemode:=StrToint(Nextval);
    LR.speed:=StrTofloat(Nextval);
    LR.poi_latitude:=StrTofloat(Nextval);
    LR.poi_longitude:=StrToFloat(Nextval);
    LR.poi_altitude:=StrToFloat(Nextval);
    LR.poi_altitudeMode:=StrToint(Nextval);
    LR.photo_timeinterval:=StrToint(Nextval);
    LR.photo_distinterval:=StrtoFloat(Nextval);
    EllinKonf(1,9,a,f,LR.latitude,LR.longitude,x,y,c,m);
    setlength(LWP,Length(LWP)+1);
    LWP[high(LWP)]:=LR;
  until eof(tf) ;
  closefile(tf);
  Numberboxactrec.Max:=High(LWP);
  Numberboxactrec.Value:=0;
//  NumberBoxActrecChange(self);
end;

Procedure TMainForm.ShowLitchiCVS(i:Integer);
var j:Integer;
begin
  AktLitchRec:=i;
  Numberboxlat.Value:=Lwp[i].latitude;
  Numberboxlon.Value:=LWP[i].longitude;
  Numberboxalt.Value:=LWP[i].altitude;
  NumberboxAltMode.value:=LWP[i].altitudemode;
  NumberboxHead.Value:=LWP[i].heading;
  NumberboxCuSz.Value:=LWP[i].curvesize;
  NumberboxRotdir.Value:=LWP[i].rotationdir;
  NumberboxGimM.Value:=LWP[i].gimbalmode;
  NumberboxGimP.Value:=LWP[i].gimbalpitchangle;
  NumberboxSpeed.Value:=LWP[i].Speed;
  NumberboxPictS.Value:=LWP[i].photo_timeinterval;
  NumberboxPictM.Value:=LWP[i].photo_distinterval;
  NumberboxPoiLat.Value:=LWP[i].poi_latitude;
  NumberboxPoiLon.Value:=LWP[i].poi_longitude;
  NumberboxPoiAlt.Value:=LWP[i].poi_altitude;
  NumberboxPoiAltMode.Value:=LWP[i].poi_altitudemode;

  Numberboxwait.Value:=0;
  CheckBoxPhoto.IsChecked:=False;
  CheckBoxStartRec.IsChecked:=False;
  CheckBoxStopRec.IsChecked:=False;
  NumberboxRotate.value:=0;
  NumberboxTiltCam.value:=0;
  for j := Low(LWP[i].Actions) to High(LWP[i].Actions) do
  begin
    if LWP[i].Actions[j].Typ<>-1 then
    begin
      case LWP[i].Actions[j].Typ of
      0:Numberboxwait.Value:=LWP[i].Actions[j].Param/1000;
      1:CheckBoxPhoto.IsChecked:=True;
      2:CheckBoxStartRec.IsChecked:=True;
      3:CheckBoxStopRec.IsChecked:=True;
      4:NumberboxRotate.value:=LWP[i].Actions[j].Param;
      5:NumberboxTiltCam.value:=LWP[i].Actions[j].Param;
      end;
    end;
  end;
end;

procedure TMainForm.DisplayLitchiRecs;
var i:Integer;
    c,m,Xp1,YP1,XP2,YP2,XB1,YB1,XB2,YB2:double;

begin
  if length(LWP)=0 then exit;
//  TrafPar;
  Tabcontrol1.GotoVisibleTab(1);


  for i:=low(LWP) to high(LWP)-1 do
  begin
    ELLinKONF(1,9,a,f,LWP[i].latitude,LWP[i].longitude,Xp1,YP1,C,M);
    ELLinKONF(1,9,a,f,LWP[i+1].latitude,LWP[i+1].longitude,Xp2,YP2,C,M);
    Trafback(Xp1,Yp1,xb1,yb1);
    Trafback(Xp2,Yp2,xb2,yb2);
    if Imageviewer2.Canvas.BeginScene then
    try
      Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Yellow;
      Imageviewer2.canvas.Fill.Color:=TAlphaColors.Yellow;
      Imageviewer2.Canvas.Stroke.Thickness:=1;
      Imageviewer2.Canvas.DrawLine(TpointF.Create(XB1,YB1),TpointF.Create(XB2,YB2),100);
      Imageviewer2.Canvas.FillEllipse(TrectF.Create(xb2-5,yb2-5,xb2+5,yb2+5),100);
    finally
      Imageviewer2.Canvas.endScene
    end;

    if LWP[i].poi_latitude>0 then
    begin
      ELLinKONF(1,9,a,f,LWP[i].Poi_latitude,LWP[i].POI_longitude,Xp1,YP1,C,M);
      ELLinKONF(1,9,a,f,LWP[i+1].POI_latitude,LWP[i+1].POI_longitude,Xp2,YP2,C,M);
      Trafback(Xp1,Yp1,xb1,yb1);
      Trafback(Xp2,Yp2,xb2,yb2);
      if Imageviewer2.Canvas.BeginScene then
      try
        Imageviewer2.Canvas.Stroke.Color := TAlphaColors.Cyan;
        Imageviewer2.canvas.Fill.Color:=TAlphaColors.Cyan;
        Imageviewer2.Canvas.DrawLine(TpointF.Create(XB1,YB1),TpointF.Create(XB2,YB2),100);
        Imageviewer2.Canvas.FillEllipse(TrectF.Create(xb2-10,yb2-10,xb2+10,yb2+10),100);
      finally
        Imageviewer2.Canvas.endScene
      end;
    end;
  end;

  Numberboxactrec.Max:=High(LWP);
end;

procedure TMainForm.EditBFNameDblClick(Sender: TObject);
begin
  if Savedialog1.Execute then
  begin
    EditBFName.text:=Savedialog1.FileName;
    Rasterfilename:=EditBFName.Text;
  end;
end;

procedure TMainForm.WriteLitchiCVS;

var fn:textfile;
    i,j:Integer;
begin
   if pos('.',EditCvs.text)=0 then EditCvs.Text:=EditCVS.Text+'.CSV';
   Assignfile(fn,EditCVS.Text);
   rewrite(fn);
//   Header:='latitude,longitude,altitude(m),heading(deg),curvesize(m),rotationdir,gimbalmode,gimbalpitchangle,actiontype1,actionparam1,actiontype2,actionparam2,actiontype3,actionparam3,actiontype4,actionparam4,actiontype5,actionparam5,actiontype6,actionparam6,actiontype7,actionparam7,actiontype8,actionparam8,actiontype9,actionparam9,actiontype10,actionparam10,actiontype11,actionparam11,actiontype12,actionparam12,actiontype13,actionparam13,actiontype14,actionparam14,actiontype15,actionparam15,altitudemode,speed(m/s),poi_latitude,poi_longitude,poi_altitude(m),poi_altitudemode,photo_timeinterval,photo_distinterval';
   Write(fn,'latitude,longitude,altitude(m),heading(deg),curvesize(m),rotationdir,gimbalmode,gimbalpitchangle,actiontype1,actionparam1,actiontype2,actionparam2,actiontype3,actionparam3,actiontype4,actionparam4,actiontype5,actionparam5,');
   Write(fn,'actiontype6,actionparam6,actiontype7,actionparam7,actiontype8,actionparam8,actiontype9,actionparam9,actiontype10,actionparam10,actiontype11,actionparam11,actiontype12,actionparam12,');
   Writeln(fn,'actiontype13,actionparam13,actiontype14,actionparam14,actiontype15,actionparam15,altitudemode,speed(m/s),poi_latitude,poi_longitude,poi_altitude(m),poi_altitudemode,photo_timeinterval,photo_distinterval');
//latitude,longitude,altitude(m),heading(deg),curvesize(m),rotationdir,gimbalmode,gimbalpitchangle,actiontype1,actionparam1,actiontype2,actionparam2,actiontype3,actionparam3,actiontype4,actionparam4,actiontype5,actionparam5,actiontype6,actionparam6,actiontype7,actionparam7,actiontype8,actionparam8,actiontype9,actionparam9,actiontype10,actionparam10,actiontype11,actionparam11,actiontype12,actionparam12,actiontype13,actionparam13,actiontype14,actionparam14,actiontype15,actionparam15,altitudemode,speed(m/s),poi_latitude,poi_longitude,poi_altitude(m),poi_altitudemode,photo_timeinterval,photo_distinterval
//latitude	longitude	altitude(m)	heading(deg)	curvesize(m)	rotationdir	gimbalmode	gimbalpitchangle	actiontype1	actionparam1	actiontype2	actionparam2	actiontype3	actionparam3	actiontype4	actionparam4	actiontype5	actionparam5	actiontype6	actionparam6	actiontype7	actionparam7	actiontype8	actionparam8	actiontype9	actionparam9	actiontype10	actionparam10	actiontype11	actionparam11	actiontype12	actionparam12	actiontype13	actionparam13	actiontype14	actionparam14	actiontype15	actionparam15	altitudemode	speed(m/s)	poi_latitude	poi_longitude	poi_altitude(m)	poi_altitudemode	photo_timeinterval	photo_distinterval

   for i:=0 to high(LWP) do
   begin
    With LWP[i] do
    begin
      write(fn,Format('%10.6f,%10.6f,%10.3f,%10.4f,%5.1f,%10.4f,%2d,%5.1f,',[latitude,longitude,altitude,Heading,curvesize,rotationdir,Gimbalmode,Gimbalpitchangle]));
      for j:=1 to 15 do  Write(fn,Format('%d,%4f,',[Actions[j].Typ,Actions[j].Param]));
      write(fn,Format('%d,%5.1f,%10.6f,%10.6f,%10.3f,%5d,',[altitudemode,speed,poi_latitude,Poi_longitude,poi_altitude,Poi_altitudemode]));
      writeln(fn,Format('%5d,%4.0f',[photo_Timeinterval,photo_distinterval]));
    end;
   end;
   Closefile(fn);
end;

Function TMainform.FindNearestPOI(n:integer):Integer;
var i,j:Integer;
    d,dmin:double;
begin
  dmin:=1E12;j:=-1;
  for i:=low(Pt) to high(Pt) do
  if pt[i].Typ=4 then
  begin
    d:=sqrt(sqr(Pt[i].xb-Pt[n].xb)+sqr(Pt[i].yb-pt[n].yb));
    if d<dmin then
    begin
      dmin:=d;j:=i;
    end;
  end;
  Result:=j;
end;

Procedure TMainForm.MakeFreeLitchiLines;
var i,np:Integer;
    E,N,B,l,c,M,az,D:Double;
begin
  setlength(LWP,0);
  For i:=low(FreeL) to high(Freel) do
  begin
    setlength(LWP,length(LWP)+1);
    N:=Pt[FreeL[i][0]].N; E:=Pt[FreeL[i][0]].E;
    Heading(pt[FreeL[i][0]],pt[FreeL[i][1]],az,d);
    KONFinEll(1,a,f,N,E,B,L,C,M);
    LWP[high(LWP)].latitude:=B;
    LWP[high(LWP)].longitude:=L;
    LWP[high(LWP)].heading:=az;
    np:=FindNearestpoi(FreeL[i][0]);
    if np>=0 then
    begin
      E:=Pt[np].N; N:=Pt[np].E;
      KONFinEll(1,a,f,N,E,B,L,C,M);
      LWP[high(LWP)].poi_latitude:=B;
      LWP[high(LWP)].Poi_longitude:=L;
    end;
//    LWP[high(LWP)].altitude:=NumberBoxH.value;
//    LWP[high(LWP)].photo_timeinterval:=Trunc(NumberBoxFrames.value);

    setlength(LWP,length(LWP)+1);
    N:=Pt[FreeL[i][1]].N; E:=pt[Freel[i][1]].E;
    KONFinEll(1,a,f,N,E,B,L,C,M);
    LWP[high(LWP)].latitude:=B;
    LWP[high(LWP)].longitude:=L;

    np:=FindNearestpoi(FreeL[i][1]);
    if np>=0 then
    begin
      N:=Pt[np].N; E:=Pt[np].E;
      KONFinEll(1,a,f,N,E,B,L,C,M);
      LWP[high(LWP)].poi_latitude:=B;
      LWP[high(LWP)].Poi_longitude:=L;
    end;

 //      LWP[high(LWP)].altitude:=NumberBoxH.value;
//      LWP[high(LWP)].photo_timeinterval:=Trunc(NumberBoxFrames.value);
  end;
  NumberboxactRec.Max:=High(LWP);
end;

Procedure TMainForm.MakeLitchiLines;
var i:Integer;
    E,N,B,l,c,M,az,D:Double;
begin
  setlength(LWP,0);
  For i:=low(Lfly) to high(LFly) do
  begin
    setlength(LWP,length(LWP)+1);
    if i mod 2=0 then
    begin
      E:=pfly[Lfly[i][0]][0]; N:=pfly[Lfly[i][0]][1];
      KONFinEll(1,a,f,N,E,B,L,C,M);
      LWP[high(LWP)].latitude:=B;
      LWP[high(LWP)].longitude:=L;
      LWP[high(LWP)].altitude:=NumberBoxH.value;
      LWP[high(LWP)].speed:=NumberboxV.Value/3.6;
      LWP[high(LWP)].photo_timeinterval:=Trunc(NumberBoxFrames.value);

      setlength(LWP,length(LWP)+1);
      E:=pfly[Lfly[i][1]][0]; N:=pfly[Lfly[i][1]][1];
      KONFinEll(1,a,f,N,E,B,L,C,M);
      LWP[high(LWP)].latitude:=B;
      LWP[high(LWP)].longitude:=L;
      LWP[high(LWP)].altitude:=NumberBoxH.value;
      LWP[high(LWP)].speed:=NumberboxV.Value/3.6;
      LWP[high(LWP)].photo_timeinterval:=Trunc(NumberBoxFrames.value);

    end
    else
    begin
      E:=pfly[Lfly[i][1]][0]; N:=pfly[Lfly[i][1]][1];
      KONFinEll(1,a,f,N,E,B,L,C,M);
      LWP[high(LWP)].latitude:=B;
      LWP[high(LWP)].longitude:=L;
      LWP[high(LWP)].altitude:=NumberBoxH.value;
      LWP[high(LWP)].speed:=NumberboxV.Value/3.6;
      LWP[high(LWP)].photo_timeinterval:=Trunc(NumberBoxFrames.value);

      setlength(LWP,length(LWP)+1);
      E:=pfly[Lfly[i][0]][0]; N:=pfly[Lfly[i][0]][1];
      KONFinEll(1,a,f,N,E,B,L,C,M);
      LWP[high(LWP)].latitude:=B;
      LWP[high(LWP)].longitude:=L;
      LWP[high(LWP)].altitude:=NumberBoxH.value;
      LWP[high(LWP)].speed:=NumberboxV.Value/3.6;
      LWP[high(LWP)].photo_timeinterval:=Trunc(NumberBoxFrames.value);
     end;
  end;
  NumberboxactRec.Max:=High(LWP);
  DisplayLitchiRecs;
end;

Procedure TMainform.ShowGrafik;
begin
//  trafpar;
  Trafall;
  Imageviewer2.Canvas.BeginScene;
  imageviewer2.Bitmap.Assign(Imageviewer1.Bitmap);
//  ClearRect(imageviewer2.AbsoluteRect);
  Imageviewer2.Canvas.EndScene;
  if length(P)>0 then Showpoints;
  If Length(LFly)>0 then FlightLines;
  If length(FreeL)>0 then showFreeline;
  If orbit<>NIL then Orbit.Show;
end;

Procedure TflightRaster.Make;
begin
  if Raster=Nil then raster:=TflightRaster.Create;
//  raster.map:=splitfilename(Rasterfilename,
  raster.a:=aa;
  raster.o:=oo;
  raster.m:=mf;
  raster.xaoff:=xsa;
  raster.yaoff:=ysa;
  raster.xnoff:=xsn;
  raster.ynoff:=ysn;
  raster.npoints:=High(pt);
  raster.nPoly:=high(Pol);
  raster.nFly:=high(LFly);
  raster.nFreel:=high(Freel);
  raster.nOrbit:=0;
  setlength(Raster.P,Length(Pt));
  Move(Pt,Raster.P,length(Pt));
  Move(pol,raster.poly,length(pol));
  Move(Lfly,raster.Lfy,length(Lfly));
  Move(Freel,raster.FreeL,length(Freel));
end;

Procedure TFlightRaster.Write;
var f:Tfilestream;
    count:longint;
begin
  f:=Tfilestream.Create(RasterfileName,fmCreate);
  count:=f.Write(Raster,sizeof(Raster));
  f.free;
end;

Procedure TFlightRaster.Read;
begin

end;

end.
